package proto.flight.service;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

import framework.service.LocalService;

import proto.flight.exception.FlightDomainException;
import proto.flight.view.BaseView;

public abstract class FlightBaseService<T> extends LocalService<T> {
    protected Log log;

    public FlightBaseService() {
        this.log = LogFactory.getLog(this.getClass());
    }

    //this class may contain auxiliary methods used in all remote invocation services

    @Override
    protected abstract T action() throws FlightDomainException;

    @Override
    protected void after() throws FlightDomainException {
    }

    @Override
    protected void before() throws FlightDomainException {
    }

}
